
#include once "vbcompat.bi"
#include once "string.bi"
#include once "log.bi"
#include once "uci.bi"
#include once "player.bi"
#include once "validator.bi"
#include once "version.bi"

const STARTPOS = "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1"

dim player as TArtificialChessPlayer
dim flag as byte

OpenLog("mosquito-" & format(now, "yyyymmddhhnnss") & ".log")
ToLog(PROGRAM_INFO)

dim as string cmd = "", ss(), fen = STARTPOS, move
dim exitLoop as boolean = false

while not exitLoop
  sleep 10
  input "", cmd
  ToLog("<< " & cmd)
  
  if uci.IsCommandQuit(cmd) then
    exitLoop = true
  
  elseif uci.IsCommandUCI(cmd) then
    print("id name " & PROGRAM_NAME & " " & PROGRAM_VERSION)
    print("id author " & AUTHOR_NAME)
    print("uciok")
  
  elseif uci.IsCommandReady(cmd) then
    print("readyok")
  
  elseif uci.IsCommandNewGame(cmd)  then
  
  elseif uci.IsCommandPosition(cmd) then
    if uci.IsCommandStartPos(cmd) then
      player.Initialize(STARTPOS)
      
      if uci.IsCommandMoves(cmd) andalso uci.GetMoves(cmd, ss()) then
        for i as integer = lbound(ss) to ubound(ss)
          player.UserMove(ss(i))
        next i
      end if
    
    elseif uci.IsCommandFEN(cmd) then
      uci.GetFEN(cmd, fen)
      if IsFEN(fen) then
        player.Initialize(fen)
      else
        ToLog("** Invalid FEN string: " & fen)
        player.Initialize(STARTPOS)
      end if
    end if
  
  elseif uci.IsCommandGo(cmd) then
    move = player.BestMove(flag)
    print("bestmove " & move)
    if flag > 1 then
      ToLog("** The engine sent an illegal move")
    end if
  end if
wend

CloseLog
